from tweet import Tweet
from tfidf import TfIdf
from recenttweets import RecentTweets
from buckets import Bucket, BucketsDB
from datetime import datetime
from operator import itemgetter
import sys, json, utils, math

L = 36
K = 13
QUEUE_SIZE = 20
RECENT_TWEETS = 2000
MIN_TOKENS = 2

IGNORE = ['i', 'im', 'me', 'mine', 'you', 'yours']

oovMap = {}

buckets = BucketsDB(L, K, QUEUE_SIZE)
recent = RecentTweets(RECENT_TWEETS)

def getClosestNeighborBuckets(tweet):
    poss = buckets.getPossibleNeighbors(tweet)
    aggr = {}
    look = {}
    for e in poss:
        if e.msgid in aggr:
            aggr[e.msgid] += 1
        else:
            aggr[e.msgid] = 1
            look[e.msgid] = e
    neigh = sorted(aggr.iteritems(), key=itemgetter(1), reverse=True)
    neigh = [z[0] for z in neigh[:min(len(neigh),(3*L))]]
    neigh = [look[k] for k in neigh]
    return utils.closestCossim(tweet, neigh)

def getClosestNeighborRecent(tweet, cosBuck):
    close = (None,-2.0)
    if ((1-cosBuck) >= 0.5):
        close = recent.getClosestNeighbor(tweet)
    recent.insert(tweet)
    return close

def decideClosest(bcks, rec):
    if bcks[1] > rec[1]:
        return bcks
    else:
        return rec

tweet = None
done = 0
starttime = 0
systime = datetime.now()

with open(sys.argv[1]) as f:
    for l in f:
        ws = l.split()
        k = unicode(ws[0])
        v = unicode(ws[1])
        oovMap[k] = v

skipped = 0

for l in sys.stdin:
    t = json.loads(l)
    msg = t['tweet']
    ts = int(t['timestamp'])
    msgid = int(t['id'])
    uid = int(t['user']['id'])
    if utils.qualified(msg, IGNORE, MIN_TOKENS):
        tweet = Tweet(msg, ts, msgid, uid)
        incr = TfIdf.getVals(tweet, oovMap)
        buckets.updateRndVec(incr)
        closeBuck = getClosestNeighborBuckets(tweet)
        closeRecent = getClosestNeighborRecent(tweet, closeBuck[1])
        closeoverall = decideClosest(closeBuck,closeRecent)
        other = closeoverall[0]
        if other:
            t['nearneigh'] = other.msgid
        else:
            t['nearneigh'] = -1
        t['cossim'] = closeoverall[1]
        sys.stdout.write(json.dumps(t) + '\n')
    else:
        skipped += 1
    done += 1
    current = int(ts) / 1000
    if current-starttime > 900:
        aftertime = datetime.now()
        delta = aftertime-systime
        systime = aftertime
        dt = divmod(delta.seconds,60)
        sys.stderr.write(str(done) + ' Tweets done in ' + str(dt[0]) + ' min ' + str(dt[1]) + ' sec.\n')
        starttime = current
sys.stderr.write('Processed ' + str(done) + ' tweets in total.\n')
sys.stderr.write('Skipped a total of ' + str(skipped) + ' tweets.\n')
