#!/usr/bin/python
import xml.etree.ElementTree as ET
import sys, tarfile, StringIO, gensim, os, json
from stat import *
tscores = {}

def getTxt(item):
    xml = ET.fromstring(item)
    text = xml.find('body/body.content/block[@class="full_text"]')
    if text is None:
        return ''
    else:
        body = ''
        for l in text:
            body += l.text
        return body

def getTopic(txt, m):
    w = []
    d = m.id2word
    for word in txt.lower().split():
        if 'http' in word:
            w.append('LINK')
        else:
            w.append(word)
    bow = d.doc2bow(w)
    s = sorted(m[bow], key=lambda tup: tup[1], reverse=True)
    return s[0][0]

def openDirs(path, m):
    for f in os.listdir(path):
        pathname = os.path.join(path, f)
        mode = os.stat(pathname)[ST_MODE]
        if S_ISDIR(mode):
            openDirs(pathname, m)
        elif S_ISREG(mode):
            openTar(pathname, m)

def openTar(fname, m):
    tar = tarfile.open(fname)
    for tarinfo in tar:
        out = StringIO.StringIO()
        if tarinfo.isfile():
            buf = tar.extractfile(tarinfo)
            for line in buf:
                out.write(line)
            buf.close()
            txt = getTxt(out.getvalue())
            out.close()
            i = getTopic(txt, m)
            if i not in tscores:
                tscores[i] = 1
            else:
                tscores[i] += 1
        tar.members = []

if len(sys.argv) < 3:
    print >> sys.stderr, 'Must supply filename or path to parse and LDA model'
else:
    m = gensim.models.ldamodel.LdaModel.load(sys.argv[2])
    if os.path.isdir(sys.argv[1]):
        openDirs(sys.argv[1], m)
    else:
        openTar(sys.argv[1], m)
    o = {}
    o["cat"] = []
    cand = sorted(tscores.items(), key=lambda tup: tup[1], reverse=True)
    for i in cand[:3]:
        o["cat"].append(i[0])

    with open('categories.json', 'w') as f:
        f.write(json.dumps(o) + '\n')
