#!/usr/bin/python
# coding: utf-8
import logging, json, gensim, sys, os

logging.basicConfig(format='%(asctime)s : %(levelname)s : %(message)s', level=logging.INFO)
# Put topic numbers you want tweets printed for in below list
cand = []

def is_int(s):
    try:
        int(s)
        return True
    except ValueError:
        return False

def handle_tweets(tweets, ldapath):
    cand = json.loads(open('categories.json').read())["cat"]
    lda = gensim.models.ldamodel.LdaModel.load(ldapath)
    dic = lda.id2word
    filtered = []
    for t in tweets:
        s = t["tweet"]
        d = []
        for word in s.lower().split():
            if 'http' in word:
                d.append(u'LINK')
            else:
                d.append(word)
        conv = dic.doc2bow(d)
        mini = sorted(lda[conv], key=lambda tup: tup[1], reverse=True)
        if mini[0][1] > 0.4 and mini[0][0] in cand:
            t["score"] = mini[0][1]
            filtered.append(t)

    return filtered

def main(ldapath, filename):

    with open(filename, 'ab') as f:
        f.write('{"data":[')

    size = 0
    iteration = 0
    tweets = []
    for line in sys.stdin:
        if is_int(line):
            size = int(line)
            iteration = 0
        else:
            tweets.append(json.loads(line))
            iteration += 1
            if iteration >= size:
                filtered = handle_tweets(tweets, ldapath)
                with open(filename, 'ab') as f:
                    for tweet in filtered:
                        sys.stdout.write(json.dumps(tweet) + '\n')
                        f.write(json.dumps(tweet) + ',')
                tweets = []

    if tweets:
        filtered = handle_tweets(tweets, ldapath)
        with open(filename, 'ab') as f:
            for tweet in filtered:
                sys.stdout.write(json.dumps(tweet) + '\n')
                f.write(json.dumps(tweet) + ',')

filename='out.json'

if len(sys.argv) < 2:
    print >> sys.stderr, 'Usage: python stream-testing.py path/to/lda'
else:
    try:
        main(sys.argv[1], filename)
    except (KeyboardInterrupt, SystemExit):
        with open(filename, 'rb+') as f:
            f.seek(-1, os.SEEK_END)
            f.truncate()
        with open(filename, 'a') as f:
            f.write(']}')
        raise

    with open(filename, 'rb+') as f:
        f.seek(-1, os.SEEK_END)
        f.truncate()
    with open(filename, 'a') as f:
        f.write(']}')

